library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity HyperBus_simulation is
end HyperBus_simulation;

architecture Behavioral of HyperBus_simulation is

component s27kl0641 is port(
    DQ7: inout std_logic;
    DQ6: inout std_logic;
    DQ5: inout std_logic;
    DQ4: inout std_logic;
    DQ3: inout std_logic;
    DQ2: inout std_logic;
    DQ1: inout std_logic;
    DQ0: inout std_logic;
    RWDS: inout std_logic;
    CSNeg: in std_logic;
    CK: in std_logic;
    RESETNeg: in std_logic);
end component;

signal nReset: std_logic:='1';
signal nCS: std_logic:='1';
signal CK: std_logic:='0';
signal RWDS: std_logic:='Z';
signal DQ: std_logic_vector(7 downto 0):=x"00";

begin
	
RAM: s27kl0641 port map(
    DQ7 => DQ(7),
    DQ6 => DQ(6),
    DQ5 => DQ(5),
    DQ4 => DQ(4),
    DQ3 => DQ(3),
    DQ2 => DQ(2),
    DQ1 => DQ(1),
    DQ0 => DQ(0),
    RWDS => RWDS,
    CSNeg => nCS,
    CK => CK,
    RESETNeg => nReset);

process begin
	RWDS <= 'Z';
	DQ <= x"00";
	wait for 200 us;
	nReset <= '0';
	wait for 400 ns;
	nReset <= '1';
	wait for 1 us;
	
	-- WRITE
	nCS <= '0';
	wait for 10.1 ns;
	DQ <= x"20";
	wait for 2.4 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"01";
	wait for 2.4 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"01";
	wait for 2.4 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 2.5 ns;
	RWDS <= '0';
	wait for 2.5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"01";
	wait for 2.4 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"a0";
	wait for 2.4 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"00";
	RWDS <= 'Z';
	nCS <= '1';
	wait for 1 us;
	
	-- READ
	nCS <= '0';
	wait for 10.1 ns;
	DQ <= x"A0";
	wait for 2.4 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"01";
	wait for 2.4 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '1';
	wait for 2.6 ns;
	DQ <= x"01";
	wait for 2.4 ns;
	CK <= '0';
	wait for 2.6 ns;
	DQ <= x"00";
	wait for 2.4 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	DQ <= "ZZZZZZZZ";
	CK <= '0';
	wait for 5 ns;
	CK <= '1';
	wait for 5 ns;
	CK <= '0';
	wait for 2.6 ns;
	nCS <= '1';
	wait for 2.4 ns;
	DQ <= x"00";
	wait;
end process;

end Behavioral;